/*******************************************************************
* FILENAME: utils.h
*
* DESCRIPTION:
*	Prototypes for functions in utils.cpp, used by instvc.dll
*
* REFERENCES:
*
********************************************************************/

#include <stdio.h>

#define RTN_OK 0
#define RTN_USAGE 1
#define RTN_ERROR 13
#define GUIDSTR_MAX 38

#ifndef STATUS_SUCCESS
#define STATUS_SUCCESS  ((NTSTATUS)0x00000000L)
#endif

#ifndef STR2UNI
#define STR2UNI(unistr, regstr) \
        mbstowcs (unistr, regstr, strlen (regstr)+1);
#define UNI2STR(regstr, unistr) \
        wcstombs (regstr, unistr, wcslen (unistr)+1);
#endif

// functions from utils.cpp
DWORD SetAccountRights( LPWSTR User, LPWSTR Privilege );
int AddCategory();
void InitLsaString( PLSA_UNICODE_STRING LsaString, LPWSTR String );
NTSTATUS SetPrivilegeOnAccount(	LSA_HANDLE PolicyHandle, PSID AccountSid, LPWSTR PrivilegeName );
NTSTATUS OpenPolicy( DWORD DesiredAccess, PLSA_HANDLE PolicyHandle );
BOOL HasEXEExtension( const char *filename );
DWORD CreateNewSD( SECURITY_DESCRIPTOR **SD );
DWORD MakeSDAbsolute( PSECURITY_DESCRIPTOR OldSD, PSECURITY_DESCRIPTOR *NewSD );
DWORD SetNamedValueSD( HKEY RootKey, LPWSTR KeyName, LPWSTR ValueName, SECURITY_DESCRIPTOR *SD );
DWORD GetNamedValueSD( HKEY RootKey, LPWSTR KeyName, LPWSTR ValueName, SECURITY_DESCRIPTOR **SD, BOOL *NewSD );
DWORD AddPrincipalToNamedValueSD( HKEY RootKey, LPWSTR KeyName, LPWSTR ValueName, LPWSTR Principal, BOOL Permit );
DWORD RemovePrincipalFromNamedValueSD( HKEY RootKey, LPWSTR KeyName, LPWSTR ValueName, LPWSTR Principal );
DWORD GetCurrentUserSID( PSID *Sid );
DWORD GetPrincipalSID( LPWSTR Principal, PSID *Sid );
DWORD CopyACL( PACL OldACL, PACL NewACL );
DWORD AddAccessDeniedACEToACL( PACL *Acl, DWORD PermissionMask, LPWSTR Principal );
DWORD AddAccessAllowedACEToACL( PACL *Acl, DWORD PermissionMask, LPWSTR Principal );
DWORD RemovePrincipalFromACL( PACL Acl, LPWSTR Principal );
LPTSTR SystemMessage( LPWSTR szBuffer, HRESULT hr );
DWORD CopyACL( PACL OldACL, PACL NewACL );
DWORD AddAccessDeniedACEToACL( PACL *Acl, DWORD PermissionMask, LPWSTR Principal );
DWORD AddAccessAllowedACEToACL( PACL *Acl, DWORD PermissionMask, LPWSTR Principal );
DWORD RemovePrincipalFromACL( PACL Acl, LPWSTR Principal );
BOOL IsPrincipalInACL( PACL Acl, LPWSTR Principal );

#ifdef	REPORT_CALL_FAILURES

inline void ReportFailure(const char *context, const char *function, const char *file, int line)
{
	char formatBuffer[2048];

	sprintf(formatBuffer, "context: %s, function: %s, file: %s, line: %d",
		context, function, file, line);

	MessageBoxA(0, formatBuffer, __FILE__, MB_OK);
}

inline void ReportFailure2(const char *context, const char *function, const char *file, int line, int ret )
{
	char formatBuffer[2048];

	sprintf(formatBuffer, "context: %s, function: %s, file: %s, line: %d, return: %d",
		context, function, file, line, ret);

	MessageBoxA(0, formatBuffer, __FILE__, MB_OK);
}

#else

#define ReportFailure(c, f, f, l)
#define ReportFailure2(c, f, f, l, r)

#endif

